package com.tencent.qqlive.downloadproxy.tvkhttpproxy.aidl;
import com.tencent.qqlive.downloadproxy.tvkhttpproxy.aidl.TVKCGIVideoInfo;

interface ITVKPlayListenerAIDL
{

    void onPlayProgress(long current, long total);

	void onPlayInfoData(int playId, String vinfoXml, String playDataInfoStr);

	void onPlayInfoSuccess(int plaId, in TVKCGIVideoInfo videoInfo);

	void onPlayInfoError(int playId, String errorCode, String vinfoXml);

	void onPlayError(int playId, int errorGlobalCode, String errorCodeStr);

	long getPlayerBufferLength();

	long getCurrentPosition();

	int getCurrentPlayClipNo();

	long getAdvRemainTime();

	void onCurrentPlayClipDownLoadFinish(int currentPlayClipNo, int velocity);

	void onCurrentPlayClipConnectFailed(int currentPlayClipNo);

	void onCurrentPlayClipConnectSuccess(int currentPlayClipNo);

	void onCurrentVideoAllDownloadFinish(int playId);

	void onLoopVideoStartPlay(String vid);

	void onLoopAdvStartPlay(String vid);

	void onPlayByUrlError(String vid, String url);

    void onPlayRequestError(String vid, int errorType);

    void onPlayCallback(int messageType, in List ext);

	void onCurrentPlayCDNURLCallBack(int playId, String url);

	String getPlayInfo(int type);
}